# easybuild

EasyBuild is a software build and installation framework that allows you to manage software in an efficient way: (http://easybuild.readthedocs.io/en/latest/Introduction.html). This repo provides additional easyconfigs for ELIC ecosystem

## Install

```bash
rmdir /opt/easybuild/configs
git clone ssh://git@www.climate.be:3022/pbarriat/easyconfigs.git /opt/easybuild/configs
```

## Requirements

* openSUSE : 
```bash
gcc-c++ patch libopenssl-devel gperf
```

* CentOS : 
```bash 
openssl-devel libibverbs-devel liberation-fonts autoconf automake binutils bison flex gcc gcc-c++ gettext libtool make patch pkgconfig bzip2 unzip jq-devel v8-devel postgresql-devel tcsh check-devel unixODBC*
```

* ubuntu : 
```bash
gcc g++ gfortran libibverbs-dev pkg-config check
```

## Getting started

Check if you have the lastest easybuild version:

```bash
module load easybuild
pip install easybuild --upgrade --install-option "--prefix=/opt/easybuild/app"
```

Then call `screen` and :

### 2019a

```bash
eb_noarch Java-11.eb -r

cd /opt/easybuild/configs/foss-2019a
eb_2019a ./libgeotiff-1.5.1-GCCcore-8.2.0.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GSL,XML-Parser,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,libmo_unpack,SWIG,ecCodes,GEOS,YAXT,Mako,Mesa,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,FriBidi,HarfBuzz,HDF,Pango,GTK+,libglade,PyGTK,numba,LibUUID,libdap,ANTLR,DBus,Ninja,Meson,at-spi2-core,libepoxy,at-spi2-atk,Tkinter,matplotlib,FFTW,libunwind,Ghostscript,gompi,OpenBLAS,LittleCMS,ScaLAPACK,ImageMagick,SciPy-bundle,configurable-http-proxy,OpenPGM,libsodium,ZeroMQ,PyZMQ -r

eb_2019a ./GDAL-3.0.0-foss-2019a-Python-3.7.2.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GSL,XML-Parser,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,libmo_unpack,SWIG,ecCodes,GEOS,YAXT,Mako,Mesa,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,FriBidi,HarfBuzz,HDF,Pango,GTK+,libglade,PyGTK,numba,LibUUID,libdap,ANTLR,DBus,Ninja,Meson,at-spi2-core,libepoxy,at-spi2-atk,Tkinter,matplotlib,FFTW,libunwind,Ghostscript,gompi,OpenBLAS,LittleCMS,ScaLAPACK,ImageMagick,SciPy-bundle,configurable-http-proxy,OpenPGM,libsodium,ZeroMQ,PyZMQ

eb_2019a ELIC_Python-1-foss-2019a-Python-3.7.2.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GSL,XML-Parser,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,libmo_unpack,SWIG,ecCodes,GEOS,YAXT,Mako,Mesa,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,FriBidi,HarfBuzz,HDF,Pango,GTK+,libglade,PyGTK,numba,LibUUID,libdap,ANTLR,DBus,Ninja,Meson,at-spi2-core,libepoxy,at-spi2-atk,Tkinter,matplotlib,FFTW,libunwind,Ghostscript,gompi,OpenBLAS,LittleCMS,ScaLAPACK,ImageMagick,SciPy-bundle,configurable-http-proxy,OpenPGM,libsodium,ZeroMQ,PyZMQ -r

module load ELIC_Python
pip install olefile Pillow pyproj pyshp chardet urllib3 certifi requests OWSLib netCDF4 geoval cdo Shapely dask astropy oktopus bs4 tqdm cf-units cftime pyugrid cycler singledispatch backports_abc tornado toolz patsy statsmodels nc-time-axis yamale psutil bcrypt cffi cryptography Cython decorator mpi4py numpy pandas pbr pycparser scipy six virtualenv xlrd affine atomicwrites boto3 botocore click click-plugins cligj cloudpickle configobj docutils fiona geopandas jmespath more-itertools motionless munch networkx pathlib2 pluggy py pytest python-utils rasterio s3transfer scandir snuggs xarray py-expression-eval PyWavelets attrs progressbar2 scikit-image PyNaCl descartes graphviz wcwidth Bottleneck pickleshare simplegeneric prompt_toolkit Pygments ptyprocess pexpect typelib testpath parso jedi backcall scikit-learn ldap3 skills XlsxWriter retrying pyrsistent jsonschema --user

module purge
module load easybuild

eb_2019a jupyter-1.0.0-foss-2019a-Python-3.7.2.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GSL,XML-Parser,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,libmo_unpack,SWIG,ecCodes,GEOS,YAXT,Mako,Mesa,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,FriBidi,HarfBuzz,HDF,Pango,GTK+,libglade,PyGTK,numba,LibUUID,libdap,ANTLR,DBus,Ninja,Meson,at-spi2-core,libepoxy,at-spi2-atk,Tkinter,matplotlib,FFTW,libunwind,Ghostscript,gompi,OpenBLAS,LittleCMS,ScaLAPACK,ImageMagick,SciPy-bundle,configurable-http-proxy,OpenPGM,libsodium,ZeroMQ,PyZMQ -r
```
> !!! For Ubuntu/Debian only: Fix `/opt/easybuild/app/easybuild/easyconfigs/m/Mesa/Mesa-19.0.1-GCCcore-8.2.0.eb` by adding `toolchainopts = {'optarch': 'march=sandybridge'}`. Of course, `march` must be the correct one depending of the machine !!!

```bash
eb_2019a ELIC_R-1-foss-2019a-R-3.6.0.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GSL,XML-Parser,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,libmo_unpack,SWIG,ecCodes,GEOS,YAXT,Mako,Mesa,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,FriBidi,HarfBuzz,HDF,Pango,GTK+,libglade,PyGTK,numba,LibUUID,libdap,ANTLR,DBus,Ninja,Meson,at-spi2-core,libepoxy,at-spi2-atk,Tkinter,matplotlib,FFTW,libunwind,Ghostscript,gompi,OpenBLAS,LittleCMS,ScaLAPACK,ImageMagick,SciPy-bundle,configurable-http-proxy,OpenPGM,libsodium,ZeroMQ,PyZMQ -r
```

### 2018b

```bash
eb_2018b netCDF-Fortran-4.4.4-foss-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,FFTW -r

eb_2018b netCDF-C++4-4.3.0-foss-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,FFTW

eb_noarch Java-1.8.0_202.eb
eb_noarch Java-1.8.eb

cd /opt/easybuild/configs/foss-2018b

eb_2018b ./ELIC-0.1-foss-2018b-Python-2.7.15.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,libunwind,GLib,intltool,X11,cairo,libdrm,nettle,Mako,Mesa,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GDAL,GSL,XML-Parser,LibUUID,libdap,ANTLR,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,HDF,libmo_unpack,YAXT,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,numba,FriBidi,HarfBuzz,Pango,GTK+,libglade,PyGTK,ecCodes,FFTW,nodejs,orca -r

eb_2018b ./ELIC-0.1-foss-2018b-Python-3.6.6.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GDAL,GSL,XML-Parser,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,libmo_unpack,SWIG,ecCodes,GEOS,YAXT,Mako,Mesa,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,FriBidi,HarfBuzz,HDF,Pango,GTK+,libglade,PyGTK,numba,LibUUID,libdap,ANTLR,DBus,Ninja,Meson,at-spi2-core,libepoxy,at-spi2-atk,Tkinter,matplotlib,FFTW -r

cd /opt/easybuild/configs/intel-2018b

eb_2018b ./icc-2018.3.222-GCC-7.3.0-2.30.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,GCCcore,iccifort,impi,iimpi,imkl,Autoconf,Automake,ncurses,libtool,pkg-config,cURL,Szip,Autotools,CMake,Doxygen

eb_2018b ./ifort-2018.3.222-GCC-7.3.0-2.30.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,GCCcore,iccifort,impi,iimpi,imkl,Autoconf,Automake,ncurses,libtool,pkg-config,cURL,Szip,Autotools,CMake,Doxygen

eb_2018b netCDF-Fortran-4.4.4-intel-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,GCCcore,iccifort,impi,iimpi,imkl,Autoconf,Automake,ncurses,libtool,pkg-config,cURL,Szip,Autotools,CMake,Doxygen -r

eb_2018b netCDF-C++4-4.3.0-intel-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,GCCcore,iccifort,impi,iimpi,imkl,Autoconf,Automake,ncurses,libtool,pkg-config,cURL,Szip,Autotools,CMake,Doxygen

eb_2018b UDUNITS-1.12.11-intel-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,GCCcore,iccifort,impi,iimpi,imkl,Autoconf,Automake,ncurses,libtool,pkg-config,cURL,Szip,Autotools,CMake,Doxygen,expat

cd /opt/easybuild/configs/noarch

eb_noarch ./MATLAB-UCL-2017a.eb
eb_noarch ./MATLAB-UCL-2015a.eb
```

## Python2 packages

Fix `/opt/modules/all/GEOS/VERSION.lua` by adding `setenv("GEOS_DIR", root)`

```bash
pip install --upgrade pip

pip install cffi geos netcdf4 cdo geoval cartopy iris matplotlib ipython pyproj scikit-image pillow pandas xarray joblib six gdal shapely rasterio geopandas pytest boto3 salem motionless progressbar2 fiona geopandas configobj https://github.com/matplotlib/basemap/archive/v1.2.0rel.tar.gz

pip install spyder python_qt_binding python-qt Qt.py ecmwf-api-client pybufr-ecmwf PySide
```

## Python3 packages

Fix `/opt/modules/all/GEOS/VERSION.lua` by adding `setenv("GEOS_DIR", root)`

```bash
pip install --upgrade pip

pip install cffi geos netcdf4 cdo geoval cartopy matplotlib ipython pyproj scikit-image pillow pandas xarray joblib six gdal shapely rasterio geopandas pytest boto3 salem motionless progressbar2 fiona geopandas configobj https://github.com/matplotlib/basemap/archive/v1.2.0rel.tar.gz

pip install spyder python_qt_binding python-qt Qt.py ecmwf-api-client pybufr-ecmwf 
```

## R packages

```bash
module purge
module load R
cd /opt/easybuild/easyconfigs/utils
Rscript ipak.R
```

## Matlab 2013a

```bash
rsync -av 10.90.90.50:/opt/software/MATLAB/2013a /opt/software/MATLAB
scp 10.90.90.50:/opt/modules/all/MATLAB/2013a.lua /opt/modules/all/MATLAB
```